import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;
/**
 *   : 
 * @author  , '  
 * @version 27/12/2006
 */
public class CarWash
{
	private List<Car> carList ;
	public static final int BOUNDARY_OF_WASHES = 5;
	public static final int PRICE_FOR_FIRSTS_EXTERNAL_WASHES = 20;
	public static final int PRICE_FOR_FIRSTS_COMBINED_WASHES = 30;
	public static final int PRICE_FOR_LASTS_EXTERNAL_WASHES = 18;
	public static final int PRICE_FOR_LASTS_COMBINED_WASHES = 24;
	 
	public CarWash()
	{
		this.carList = new List<Car>();
	}
	 
	public boolean carExists(int carNum)
	{
		Node<Car> p = this.carList.getFirst();
		while ( p != null)
		{
					if  (p.getInfo().getCarNum()==carNum)
						return true;
					p = p.getNext();
		}
		return false;
	}
	
	public void addWashForCar (int carNum) 
	{
		Node<Car> p = carList.getFirst();
		while (p != null)
		{
			if (p.getInfo().getCarNum() == carNum)
			{
				p.getInfo().setWashTimes(p.getInfo().getWashTimes() + 1);
				return;
			}
			p = p.getNext();
		}
	    Car c = new Car (carNum);
	    this.carList.insert(null,c);
	}
	
	public int computePrice (int carNum, int type)
	{
		int washTimes =0;
		Node<Car> p = carList.getFirst();
		while (p != null)
		{
			if (p.getInfo().getCarNum() == carNum)
			{
				washTimes = p.getInfo().getWashTimes();
			}
			p = p.getNext();
		}
		
		if (washTimes < BOUNDARY_OF_WASHES)
			if ( type ==1)
				return PRICE_FOR_FIRSTS_EXTERNAL_WASHES;
			else
				return PRICE_FOR_FIRSTS_COMBINED_WASHES;
		else
		   if (type==1)
			  return PRICE_FOR_LASTS_EXTERNAL_WASHES;
		   else
			  return PRICE_FOR_LASTS_COMBINED_WASHES;
	}
	
	public String toString()
	{
		String str = "";
		Node<Car> p = this.carList.getFirst(); 
		while (p!= null)
	      {
	    	  str += "car number: "+ p.getInfo().getCarNum()+" wash times: " + p.getInfo().getWashTimes()+"\n" ;
	    	  p=p.getNext();
	      }
		return str;
	}
}
